# Matches java/common/src/main/java/com/truera/common/util/Constants.java
NORMALIZED_ID_COLUMN_NAME = "__truera_id__"
NORMALIZED_RANKING_GROUP_ID_COLUMN_NAME = "__truera_ranking_group_id__"
NORMALIZED_RANKING_ITEM_ID_COLUMN_NAME = "__truera_ranking_item_id__"
NORMALIZED_TIMESTAMP_COLUMN_NAME = "__truera_timestamp__"
NORMALIZED_EVENT_TIMESTAMP_COLUMN_NAME = "__truera_event_timestamp__"
NORMALIZED_INGESTION_TIMESTAMP_COLUMN_NAME = "__truera_ingestion_timestamp__"
NORMALIZED_PREDICTION_COLUMN_NAME = "__truera_prediction__"
NORMALIZED_LABEL_COLUMN_NAME = "__truera_label__"
NORMALIZED_TAGS_COLUMN_NAME = "__truera_tags__"
NORMALIZED_TOKENS_COLUMN_NAME = "__truera_tokens__"
NORMALIZED_EMBEDDINGS_COLUMN_NAME = "__truera_embeddings__"
NORMALIZED_INTERNAL_ID_COLUMN_NAME = "__truera_internal_id__"
NORMALIZED_ID_HASH_COLUMN_NAME = "__truera_id_hash__"

# Trace Table Columns
TRACE_ID_COLUMN_NAME = "trace_id"
TRACE_TIMESTAMP_COLUMN_NAME = "trace_timestamp"
TRACE_START_TIME_COLUMN_NAME = "start_time"
TRACE_END_TIME_COLUMN_NAME = "end_time"
TRACE_MAIN_INPUT_COLUMN_NAME = "main_input"
TRACE_MAIN_OUTPUT_COLUMN_NAME = "main_output"
TRACE_PROMPT_COLUMN_NAME = "prompt"
TRACE_METADATA_COLUMN_NAME = "trace_metadata"

# Feedback Table Columns
FEEDBACK_ID_COLUMN_NAME = "result_id"
FEEDBACK_FUNCTION_ID_COLUMN_NAME = "feedback_function_id"
FEEDBACK_FUNCTION_SCORE_COLUMN_NAME = "result"
FEEDBACK_EVALUATION_TIMESTAMP_COLUMN_NAME = "evaluation_timesamp"
FEEDBACK_METADATA_COLUMN_NAME = "feedback_metadata"

# Application Standard Columns
APP_PROJECT_ID_COLUMN_NAME = "project_id"
APP_DATA_COLLECTION_ID_COLUMN_NAME = "data_collection_id"
APP_APPLICATION_ID_COLUMN_NAME = "model_id"
APP_SPLIT_ID_COLUMN_NAME = "split_id"
APP_SPAN_COLUMN_NAME = "span"
APP_N_REQUESTS_COLUMN_NAME = "n_requests"
APP_SUCCESSFUL_REQUESTS_COLUMN_NAME = "n_successful_requests"
APP_N_CLASSES_COLUMN_NAME = "n_classes"
APP_N_TOKENS_COLUMN_NAME = "n_tokens"
APP_N_STREAM_CHUNKS_COLUMN_NAME = "n_stream_chunks"
APP_N_PROMPT_TOKENS_COLUMN_NAME = "n_prompt_tokens"
APP_N_COMPLETION_TOKENS_COLUMN_NAME = "n_completion_tokens"
APP_COST_COLUMN_NAME = "cost"

# Feedback call / span field constants
FEEDBACK_CALL_ARGS_FIELD_NAME = "args"
FEEDBACK_CALL_RET_FIELD_NAME = "ret"

SYSTEM_COLUMNS = [
    NORMALIZED_ID_COLUMN_NAME, NORMALIZED_RANKING_GROUP_ID_COLUMN_NAME,
    NORMALIZED_RANKING_ITEM_ID_COLUMN_NAME, NORMALIZED_TIMESTAMP_COLUMN_NAME,
    NORMALIZED_EVENT_TIMESTAMP_COLUMN_NAME,
    NORMALIZED_INGESTION_TIMESTAMP_COLUMN_NAME,
    NORMALIZED_PREDICTION_COLUMN_NAME, NORMALIZED_LABEL_COLUMN_NAME,
    NORMALIZED_TAGS_COLUMN_NAME, NORMALIZED_TOKENS_COLUMN_NAME,
    NORMALIZED_EMBEDDINGS_COLUMN_NAME, NORMALIZED_INTERNAL_ID_COLUMN_NAME,
    NORMALIZED_ID_HASH_COLUMN_NAME
]

SYSTEM_COLUMNS_TO_DROP = [
    NORMALIZED_EVENT_TIMESTAMP_COLUMN_NAME,
    NORMALIZED_INGESTION_TIMESTAMP_COLUMN_NAME, NORMALIZED_TAGS_COLUMN_NAME,
    NORMALIZED_TOKENS_COLUMN_NAME, NORMALIZED_EMBEDDINGS_COLUMN_NAME,
    NORMALIZED_INTERNAL_ID_COLUMN_NAME, NORMALIZED_ID_HASH_COLUMN_NAME
]
